' Ron Charlton explicitly places 'MakeEntropyTestData.vb' in the public domain.
' It may be used for any purpose.

Option Strict On
Option Explicit On

Module MakeEntropyTest_Data
	Sub MakeEntropyTestData()
		' Write a file of random bytes.
		' Created by Ron Charlton, 2008-09-23, for Visual Basic .NET
		Dim i As Integer

		Const FileName As String = "MakeEntropyTestData.out"

		' Rule of thumb: Need at least five samples in EVERY class (not just on average)
		Const count As Integer = CInt(256 * 1000)	' how many bytes to generate

		' VB 2005 creates arrays with size one greater than specified
		Dim bytes(count - 1) As Byte ' "count" bytes because it's the file size desired

		Dim r As New MTRandom()

		Dim theFunction As String = "[ERROR]"

		' write random bytes into the array in sequence
		' (Don't fiddle with i; it's used as the array index.)
		For i = 0 To count - 1
			' Get a byte value between 0 inclusive and 255 inclusive.
			' (genrand_int32() and genrand_real2() are already tested by Main())
			' Comment out all but one of the following:
			'bytes(i) = CByte(Int((r.genrand_int32() / 4294967296.0) * 256.0)) : theFunction = "genrand_int32()"
			'bytes(i) = CByte(Int(r.genrand_real2() * 256.0)) : theFunction = "genrand_real2()"
            'bytes(i) = CByte(r.genrand_intMax(255)) : theFunction = "genrand_intMax()"
			bytes(i) = CByte(r.genrand_intRange(0, 255)) : theFunction = "genrand_intRange()"
			'bytes(i) = CByte(Decimal.Floor((CDec(r.genrand_int64()) / 18446744073709551616D) * 256D)) : theFunction = "genrand_int64()"
		Next

		' Write the entire bytes() array to a file.  False == don't append.
		My.Computer.FileSystem.WriteAllBytes(FileName, bytes, False)

		' Tell the user it was done
		Console.WriteLine(ControlChars.NewLine & "{0} random bytes generated by {1} were written to", _
		 count.ToString(), theFunction)
		Console.WriteLine("file '{0}'." & ControlChars.NewLine, FileName)

		Console.WriteLine("Press the <Enter> key to continue.")
		Console.ReadLine()

	End Sub		'MakeEntropyTestData
End Module
